﻿using C1.AdoNet.OData;
using C1.DataCollection.AdoNet;
using C1.DataCollection.BindingList;
using ODataVirtualizationDemo.Model;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ODataVirtualizationDemo
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            Load += Form1_Load;
            Size = new Size(800, 500);
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            string connectionString = @"Url=https://services.odata.org/Experimental/Northwind/Northwind.svc/";
            var odataConnection = new C1ODataConnection(connectionString);
            var collectionView = new C1AdoNetVirtualDataCollection<Order>(odataConnection, "Orders");
            collectionView.PageSize = 100;

            c1FlexGrid1.BeginInvoke(new MethodInvoker(() =>
            {
                c1FlexGrid1.DataSource = new C1DataCollectionBindingList(collectionView);
                c1FlexGrid1.AllowFiltering = true;
            }));

            c1FlexGrid1.DrawMode = C1.Win.C1FlexGrid.DrawModeEnum.OwnerDraw;
            c1FlexGrid1.OwnerDrawCell += C1FlexGrid1_OwnerDrawCell;
        }

        private void C1FlexGrid1_OwnerDrawCell(object sender, C1.Win.C1FlexGrid.OwnerDrawCellEventArgs e)
        {
            if (e.Row < c1FlexGrid1.Rows.Fixed)
                return;

            if (c1FlexGrid1.Cols[e.Col].DataType == typeof(DateTimeOffset))
            {
                object value = c1FlexGrid1[e.Row, e.Col];
                e.Text = (value != null) ? ((DateTimeOffset)value).DateTime.ToString("d") : string.Empty;
            }
        }
    }
}
